/******************************/
/* LN^f[^ϊ */
/******************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	CHRWIDTH	40
#define	CHRHEIGHT	20
#define	MAXCHARA	64

#define	DTNUM		56

void	convpic(int picsize_x,int picsize_y,int chrcnt,int c_pixel[CHRWIDTH/2][CHRHEIGHT][MAXCHARA],int pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA]);

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;
	FILE	*patfp;

	int		pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA];
	int		c_pixel[CHRWIDTH/2][CHRHEIGHT][MAXCHARA];
	int		dt[DTNUM][MAXCHARA];

	int		width,height;
	int		x,y,z,c;
	int		i,j;
	int		sft;
	int		a0,a1;
	int		cnum;
	int		dflag;

	if (argc != 4 && argc != 5) {
		fprintf(stderr, "Usage: convchara infile outfile cha_number [-d]\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	cnum = atoi(argv[3]);

	dflag = 0;
	if (argc == 5) {
		if (strcmp(argv[4],"-d") == 0) {
			dflag = 1;
		} else {
			printf("Illigal Parameter:%s\n",argv[4]);
			exit(1);
		}
	}

	if (dflag == 1) {
		for (j = 0;j < 0x1c00;j ++) {
			if ( (a0 = fgetc(infp)) == EOF) {
				break;
			}
			fputc(a0,outfp);
		}
	}

	for (z = 0;z < MAXCHARA;z ++) {
		for (y = 0;y < CHRHEIGHT;y ++) {
			for (x = 0;x < CHRWIDTH;x ++) {
				pixel[x][y][z] = 0x00;
			}
		}
	}

	z = 0;
	y = 0;
	x = 0;
	c = 0x0a;
	while ( (a0 = fgetc(infp)) != EOF) {

		sft = 0x80;
		for (i = 0;i < 8;i ++) {
			a1 = ( (a0 & sft) != 0x00) ? c : 0x08;
			pixel[x+i][y][z] |= a1;
			sft /= 2;
		}

		x += 8;
		if (x >= CHRWIDTH) {
			x = 0;
			y ++;
			if (y >= CHRHEIGHT) {
				y = 0;
				if (c == 0x0a) {
					c = 0x0c;
				} else {
					c = 0x0a;
					if (dflag == 1) {
						for (j = 0;j < DTNUM;j ++) {
							if ( (a0 = fgetc(infp)) == EOF) {
								break;
							}
							dt[j][z] = a0;
						}
					}
					z ++;

					if (z >= cnum) {
						break;
					}
				}
			}
		}
	}

	convpic(CHRWIDTH,CHRHEIGHT,MAXCHARA,c_pixel,pixel);

	for (z = 0;z < cnum;z ++) {
		for (y = 0;y < CHRHEIGHT;y += 4) {
			for (x = 0;x < CHRWIDTH/2;x += 4) {
				for (j = 0;j < 4;j ++) {
					for (i = 0;i < 4;i += 2) {
						a0  = ( ( (c_pixel[x+i+0][y+j][z] & 0x02) != 0) ? 0x04 : 0x00);	/* bit2 */
						a0 |= ( ( (c_pixel[x+i+0][y+j][z] & 0x04) != 0) ? 0x20 : 0x00);	/* bit5 */
						a1  = ( ( (c_pixel[x+i+1][y+j][z] & 0x02) != 0) ? 0x01 : 0x00);	/* bit0 */
						a1 |= ( ( (c_pixel[x+i+1][y+j][z] & 0x04) != 0) ? 0x02 : 0x00);	/* bit1 */
						fputc(a0|a1,outfp);
					}
				}
			}
		}
		if (dflag == 1) {
			for (j = 0;j < DTNUM;j ++) {
				fputc(dt[j][z],outfp);
			}
		}
	}

	fclose(outfp);
	fclose(infp);

	return(0);
}


void	convpic(int picsize_x,int picsize_y,int chrcnt,int c_pixel[CHRWIDTH/2][CHRHEIGHT][MAXCHARA],int pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA])
{
	int		x,y,z;

	int		c_pixel_tmp[CHRWIDTH/2][CHRHEIGHT];

	for (z = 0;z < chrcnt;z ++) {

		for (y = 0;y < picsize_y;y ++) {
			for (x = 0;x < picsize_x/2;x ++) {
				c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
			}

			for (x = 0;x < picsize_x/2 - 1;x ++) {
				if (
					(pixel[x*2+0][y][z] == pixel[x*2+2][y][z]) && 
					(pixel[x*2+1][y][z] == pixel[x*2+3][y][z])
				) {
					if ( (x%2) == 0) {
						c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
						c_pixel[x+1][y][z] = pixel[x*2+3][y][z];
					} else {
						c_pixel[x+0][y][z] = pixel[x*2+1][y][z];
						c_pixel[x+1][y][z] = pixel[x*2+2][y][z];
					}
				}
			}

			for (x = 0;x < picsize_x/2 - 3;x ++) {
				if (
					(pixel[x*2+0][y][z] == pixel[x*2+4][y][z]) && 
					(pixel[x*2+1][y][z] == pixel[x*2+5][y][z]) &&
					(pixel[x*2+2][y][z] == pixel[x*2+6][y][z]) && 
					(pixel[x*2+3][y][z] == pixel[x*2+7][y][z])
				) {

					if (pixel[x*2+0][y][z] == pixel[x*2+2][y][z]) {
						if ( (x%4) == 0) {
							c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+1][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+4][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+7][y][z];
						} else if ( (x%4) == 1) {
							c_pixel[x+0][y][z] = pixel[x*2+7][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+2][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+5][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+6][y][z];
						} else if ( (x%4) == 2) {
							c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+3][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+4][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+5][y][z];
						} else {
							c_pixel[x+0][y][z] = pixel[x*2+1][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+2][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+3][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+6][y][z];
						}
					} else if (pixel[x*2+1][y][z] == pixel[x*2+3][y][z]) {
						if ( (x%4) == 0) {
							c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+3][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+6][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+7][y][z];
						} else if ( (x%4) == 1) {
							c_pixel[x+0][y][z] = pixel[x*2+1][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+4][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+5][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+6][y][z];
						} else if ( (x%4) == 2) {
							c_pixel[x+0][y][z] = pixel[x*2+2][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+3][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+4][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+7][y][z];
						} else {
							c_pixel[x+0][y][z] = pixel[x*2+1][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+2][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+5][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+0][y][z];
						}

					} else if (pixel[x*2+0][y][z] == pixel[x*2+1][y][z]) {
						if ( (x%4) == 0) {
							c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+1][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+6][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+7][y][z];
						} else if ( (x%4) == 1) {
							c_pixel[x+0][y][z] = pixel[x*2+7][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+4][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+5][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+6][y][z];
						} else if ( (x%4) == 2) {
							c_pixel[x+0][y][z] = pixel[x*2+2][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+3][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+4][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+5][y][z];
						} else {
							c_pixel[x+0][y][z] = pixel[x*2+1][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+2][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+3][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+0][y][z];
						}
					} else if (pixel[x*2+1][y][z] == pixel[x*2+2][y][z]) {
						if ( (x%4) == 0) {
							c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+1][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+6][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+7][y][z];
						} else if ( (x%4) == 1) {
							c_pixel[x+0][y][z] = pixel[x*2+7][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+4][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+5][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+6][y][z];
						} else if ( (x%4) == 2) {
							c_pixel[x+0][y][z] = pixel[x*2+2][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+3][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+4][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+5][y][z];
						} else {
							c_pixel[x+0][y][z] = pixel[x*2+1][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+2][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+3][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+0][y][z];
						}
					} else if (pixel[x*2+2][y][z] == pixel[x*2+3][y][z]) {
						if ( (x%4) == 0) {
							c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+1][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+6][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+7][y][z];
						} else if ( (x%4) == 1) {
							c_pixel[x+0][y][z] = pixel[x*2+7][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+4][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+5][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+6][y][z];
						} else if ( (x%4) == 2) {
							c_pixel[x+0][y][z] = pixel[x*2+2][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+3][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+4][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+5][y][z];
						} else {
							c_pixel[x+0][y][z] = pixel[x*2+1][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+2][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+3][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+0][y][z];
						}
					} else if (pixel[x*2+3][y][z] == pixel[x*2+0][y][z]) {
						if ( (x%4) == 0) {
							c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+1][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+6][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+7][y][z];
						} else if ( (x%4) == 1) {
							c_pixel[x+0][y][z] = pixel[x*2+7][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+4][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+5][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+6][y][z];
						} else if ( (x%4) == 2) {
							c_pixel[x+0][y][z] = pixel[x*2+2][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+3][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+4][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+5][y][z];
						} else {
							c_pixel[x+0][y][z] = pixel[x*2+1][y][z];
							c_pixel[x+1][y][z] = pixel[x*2+2][y][z];
							c_pixel[x+2][y][z] = pixel[x*2+3][y][z];
							c_pixel[x+3][y][z] = pixel[x*2+0][y][z];
						}
					}
				}
			}
		}

/*
		for (y = 0;y < picsize_y;y ++) {
			for (x = 0;x < picsize_x/2;x ++) {
				c_pixel_tmp[x][y] = c_pixel[x][y][z];
			}
		}

		for (y = 1;y < picsize_y;y += 2) {
			for (x = 0;x < picsize_x/2 - 3;x ++) {

				if (
					(c_pixel_tmp[x+0][y-0] == c_pixel_tmp[x+2][y-0]) &&
					(c_pixel_tmp[x+1][y-0] == c_pixel_tmp[x+3][y-0]) &&
					(c_pixel_tmp[x+0][y-1] == c_pixel_tmp[x+2][y-1]) &&
					(c_pixel_tmp[x+1][y-1] == c_pixel_tmp[x+3][y-1]) &&
					( (c_pixel_tmp[x+0][y-0] == c_pixel_tmp[x+0][y-1]) ||
					  (c_pixel_tmp[x+1][y-0] == c_pixel_tmp[x+1][y-1]) 
					)
				) {
					c_pixel[x+0][y][z] = c_pixel_tmp[x+1][y];
					c_pixel[x+1][y][z] = c_pixel_tmp[x+0][y];
					c_pixel[x+2][y][z] = c_pixel_tmp[x+3][y];
					c_pixel[x+3][y][z] = c_pixel_tmp[x+2][y];
				}

			}
		}
*/

	}

	return;
}

