/************************************/
/* wĩLN^f[^ϊ */
/************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	CHRWIDTH	40
#define	CHRHEIGHT	20
#define	MAXCHARA	60

#define	MAXLINE		255

void	convpic(int picsize_x,int picsize_y,int chrcnt,int c_pixel[CHRWIDTH/2][CHRHEIGHT][MAXCHARA],int pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA],int convpat[MAXCHARA]);

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;
	FILE	*patfp;

	int		pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA];
	int		c_pixel[CHRWIDTH/2][CHRHEIGHT][MAXCHARA];
	int		convpat[MAXCHARA];

	char	line[MAXLINE];

	int		width,height;
	int		x,y,z;
	int		i,j;
	int		sft;
	int		a0,a1;

	if (argc != 4) {
		fprintf(stderr, "Usage: convchrback infile outfile cmdfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	if ((patfp = fopen(argv[3], "r")) == NULL) {
		perror(argv[3]);
		exit(1);
	}

	for (z = 0;z < MAXCHARA;z ++) {
		convpat[z] = 0;
	}

	z = 0;
	while ( fgets(line, MAXLINE, patfp) != NULL) {
		sscanf(line,"%d",&a0);
		convpat[z] = a0;
		z ++;
		if (z >= MAXCHARA) {
			break;
		}
	}

	for (z = 0;z < MAXCHARA;z ++) {
		for (y = 0;y < CHRHEIGHT;y ++) {
			for (x = 0;x < CHRWIDTH;x ++) {
				pixel[x][y][z] = 0x09;
			}
		}
	}

	z = 0;
	y = 0;
	x = 0;
	while ( (a0 = fgetc(infp)) != EOF) {
		sft = 0x80;
		for (i = 0;i < 8;i ++) {
			a1 = ( (a0 & sft) != 0x00) ? 0x0e : 0x09;
			pixel[x+i][y][z] = a1;
			sft /= 2;
		}
		x += 8;
		if (x >= CHRWIDTH) {
			x = 0;
			y ++;
			if (y >= CHRHEIGHT) {
				y = 0;
				z ++;
				if (z >= MAXCHARA) {
					break;
				}
			}
		}
	}

	convpic(CHRWIDTH,CHRHEIGHT,MAXCHARA,c_pixel,pixel,convpat);

	for (z = 0;z < MAXCHARA;z ++) {
		for (y = 0;y < CHRHEIGHT;y += 4) {
			for (x = 0;x < CHRWIDTH/2;x += 4) {

				for (j = 0;j < 4;j ++) {

					a0 = 0;
					for (i = 0;i < 4;i ++) {
						a1 = (c_pixel[x+i][y+j][z] == 0x09) ? 0x00 : 0x01;
						a0 = a0 * 2 + a1;
					}
					a0 = a0 * 2 + 0x40;
					fputc(a0,outfp);

				}


			}
		}
	}


	fclose(infp);
	fclose(outfp);
	fclose(patfp);

	return(0);
}

void	convpic(int picsize_x,int picsize_y,int chrcnt,int c_pixel[CHRWIDTH/2][CHRHEIGHT][MAXCHARA],int pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA],int convpat[MAXCHARA])
{
	int		x,y,z;
	int		pat;

	for (z = 0;z < chrcnt;z ++) {
		for (y = 0;y < picsize_y;y ++) {
			switch (convpat[z]) {
				case 0:
					for (x = 0;x < picsize_x/2;x ++) {
						c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
					}
					break;

				case 1:
					for (x = 0;x < picsize_x/2;x ++) {
						c_pixel[x+0][y][z] = pixel[x*2+1][y][z];
					}
					break;

				case 2:
					for (x = 0;x < picsize_x/2/2;x ++) {
						c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
					}
					for (;x < picsize_x/2;x ++) {
						c_pixel[x+0][y][z] = pixel[x*2+1][y][z];
					}
					break;

				case 3:
					for (x = 0;x < picsize_x/2/2;x ++) {
						c_pixel[x+0][y][z] = pixel[x*2+1][y][z];
					}
					for (;x < picsize_x/2;x ++) {
						c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
					}
					break;

				case 4:
					for (x = 0;x < picsize_x/2;x += 2) {
						c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
						c_pixel[x+1][y][z] = pixel[x*2+3][y][z];
					}
					break;

				case 5:
					for (x = 0;x < picsize_x/2;x += 2) {
						c_pixel[x+0][y][z] = pixel[x*2+1][y][z];
						c_pixel[x+1][y][z] = pixel[x*2+2][y][z];
					}
					break;

				case 6:
					for (x = 0;x < picsize_x/2;x ++) {
						c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
						if (pixel[x*2+1][y][z] == 0x0e) {
							c_pixel[x+0][y][z] = 0x0e;
						}
					}
					break;

				case 7:
					for (x = 0;x < picsize_x/2;x ++) {
						c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
						if (pixel[x*2+1][y][z] == 0x09) {
							c_pixel[x+0][y][z] = 0x09;
						}
					}
					break;

				default:
					for (x = 0;x < picsize_x/2;x ++) {
						c_pixel[x+0][y][z] = 0x08;
					}
					break;
			}

		}
	}

	return;
}


