#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	CHRWIDTH	16
#define	CHRHEIGHT	8
#define	MAXCHARA	96
#define	OFFSET		32

void	convfont(int picsize_x,int picsize_y,int chrcnt,int c_pixel[CHRWIDTH/2][CHRHEIGHT][MAXCHARA],int pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA]);

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA];
	int		c_pixel[CHRWIDTH/2][CHRHEIGHT][MAXCHARA];

	int		width,height;
	int		x,y,z;
	int		i,j;
	int		sft;
	int		a0,a1;

	if (argc != 3) {
		fprintf(stderr, "Usage: convfont infile outfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	for (z = 0;z < MAXCHARA;z ++) {
		for (y = 0;y < CHRHEIGHT;y ++) {
			for (x = 0;x < CHRWIDTH;x ++) {
				pixel[x][y][z] = 0x08;
			}
		}
	}

	for (z = 0;z < OFFSET;z ++) {
		for (y = 0;y < CHRHEIGHT;y ++) {
			for (x = 0;x < CHRWIDTH/8;x ++) {
				fgetc(infp);
			}
		}
	}


	z = 0;
	y = 0;
	x = 0;
	while ( (a0 = fgetc(infp)) != EOF) {
		sft = 0x80;
		for (i = 0;i < 8;i ++) {
			a1 = ( (a0 & sft) != 0x00) ? 0x0f : 0x08;
			pixel[x+i][y][z] = a1;
			sft /= 2;
		}
		x += 8;
		if (x >= CHRWIDTH) {
			x = 0;
			y ++;
			if (y >= CHRHEIGHT) {
				y = 0;
				z ++;
				if (z >= MAXCHARA) {
					break;
				}
			}
		}
	}

	convfont(CHRWIDTH,CHRHEIGHT,MAXCHARA,c_pixel,pixel);

	for (z = 0;z < MAXCHARA;z ++) {
		for (y = 0;y < CHRHEIGHT;y ++) {
			a0 = 0;
			for (x = 0;x < CHRWIDTH/2;x ++) {
				a1 = (c_pixel[x][y][z] == 0x08) ? 0x00 : 0x01;
				a0 = a0 * 2 + a1;
			}
			fputc(a0,outfp);
		}
	}


	fclose(outfp);
	fclose(infp);

	return(0);
}

void	convfont(int picsize_x,int picsize_y,int chrcnt,int c_pixel[CHRWIDTH/2][CHRHEIGHT][MAXCHARA],int pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA])
{
	int		x,y,z;
	int		pat;

	for (z = 0;z < chrcnt;z ++) {
		for (y = 0;y < picsize_y;y ++) {
			for (x = 0;x < picsize_x/2;x ++) {
				c_pixel[x+0][y][z] = pixel[x*2+0][y][z];
			}
		}
	}

	return;
}


