/***********************************************/
/* file ganerate for XANADU                    */
/***********************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	S_LEN		48
#define	MAXTRACK	80
#define	MAXSEC		5
#define	SECBYTE		0x400
#define	MAXFILE		0x40
#define	TR0SEC		16
#define	TR0BYTE		0x100
#define	TRACK0FILE	"TRACK0"

#define	CLSIZE		0x400
#define	CLOFFSET	(8*0x200)

/*
track0x00:C=00 H=00 R=01 N=01=0x100
track0x00:C=00 H=00 R=02 N=01=0x100
track0x00:C=00 H=00 R=03 N=01=0x100
track0x00:C=00 H=00 R=04 N=01=0x100
track0x00:C=00 H=00 R=05 N=01=0x100
track0x00:C=00 H=00 R=06 N=01=0x100
track0x00:C=00 H=00 R=07 N=01=0x100
track0x00:C=00 H=00 R=08 N=01=0x100
track0x00:C=00 H=00 R=09 N=01=0x100
track0x00:C=00 H=00 R=0a N=01=0x100
track0x00:C=00 H=00 R=0b N=01=0x100
track0x00:C=00 H=00 R=0c N=01=0x100
track0x00:C=00 H=00 R=0d N=01=0x100
track0x00:C=00 H=00 R=0e N=01=0x100
track0x00:C=00 H=00 R=0f N=01=0x100
track0x00:C=00 H=00 R=10 N=01=0x100
track0x00:C=00 H=00 R=f5 N=03=0x400 (CRC error)
track0x00:C=00 H=00 R=f6 N=03=0x400 (CRC error)
track0x00:C=00 H=00 R=f7 N=03=0x400 (CRC error)

track0x01:C=00 H=01 R=01 N=03=0x400
track0x01:C=00 H=01 R=02 N=03=0x400
track0x01:C=00 H=01 R=03 N=03=0x400
track0x01:C=00 H=01 R=04 N=03=0x400
track0x01:C=00 H=01 R=05 N=03=0x400
:
track0x4f:C=27 H=01 R=01 N=04=0x400
track0x4f:C=27 H=01 R=02 N=04=0x400
track0x4f:C=27 H=01 R=03 N=04=0x400
track0x4f:C=27 H=01 R=04 N=04=0x400
track0x4f:C=27 H=01 R=05 N=04=0x400
*/

/*
NX^AFAT̊TOȂ
track0x01:C=00 H=01 R=01 N=03=0x400
Ƀt@CXg
*/

int main(int argc, char **argv)
{
	unsigned char	diskimg[MAXTRACK][MAXSEC][SECBYTE];
	unsigned char	track0[TR0SEC][TR0BYTE];
	char	outfile[S_LEN];
	FILE	*infp, *outfp;
	int		c,i,j,k;
	int		stflag;
	int		secnum;

	int		fileno,fileptr;
	int		f_sttrk,f_stsec,f_edtrk,f_edsec;

	int		a0,a1,a2,a3;

	int		seclen[4] = {128,256,512,1024};

	if (argc != 2) {
		fprintf(stderr, "Usage: xanadu2file infile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	for (i = 0;i < MAXTRACK;i ++) {
		fseek(infp,i*4 + 0x20,SEEK_SET);
		a0 = fgetc(infp);
		a1 = fgetc(infp);
		a2 = fgetc(infp);
		a3 = fgetc(infp);

/* gbN̐擪 */
		fseek(infp,a3*0x1000000+a2*0x10000+a1*0x100+a0,SEEK_SET);

		fgetc(infp);	/* C */
		fgetc(infp);	/* H */
		fgetc(infp);	/* R */
		fgetc(infp);	/* N */
		secnum = fgetc(infp);	/* ̃gbÑZN^ */

		fseek(infp,a3*0x1000000+a2*0x10000+a1*0x100+a0,SEEK_SET);

		for (j = 0;j < secnum;j ++) {

			a0 = fgetc(infp);	/* C */
			a1 = fgetc(infp);	/* H */
			a2 = fgetc(infp);	/* R */
			a3 = fgetc(infp);	/* N */

			// printf("CHRN= %02x:%02x:%02x:%02x\n",a0,a1,a2,a3);

			if (a0 > 0x28 || a1 > 0x01) {
				printf("CH is illigal");
				printf("CHRN= %02x:%02x:%02x:%02x\n",a0,a1,a2,a3);
				exit(1);
			}

			if (i != 0 && a2 < 0xf5) {
				if (a2 < 0x01 || a2 > 0x05) {
					printf("R is illigal");
					printf("CHRN= %02x:%02x:%02x:%02x\n",a0,a1,a2,a3);
					exit(1);
				}
			}

			if (i != 0 && a3 != 0x03) {
				printf("N is illigal");
				printf("CHRN= %02x:%02x:%02x:%02x\n",a0,a1,a2,a3);
				exit(1);
			}

/* c̃ZN^pwb_ǂݔ΂ */
			for (k = 0;k < 12;k ++) {
				fgetc(infp);
			}

/* ZN^̃f[^zɊi[ */

			if (i == 0) {
				for (k = 0;k < seclen[a3];k ++) {
					if ((c = fgetc(infp)) == EOF) {
						printf("Data illigal\n");
						exit(1);
					}
					if (a2 <= 0x10) {
						track0[a2-1][k] = (unsigned char)c;
					}
				}
			} else {
				for (k = 0;k < seclen[a3];k ++) {
					if ((c = fgetc(infp)) == EOF) {
						printf("Data illigal\n");
						exit(1);
					}
					diskimg[a0*2+a1][a2-1][k] = (unsigned char)c;
				}

			}
		}

	}


/* file generate */

	strncpy(outfile,TRACK0FILE,S_LEN);
	printf("Generate file : %s\n",outfile);
	if ((outfp = fopen(outfile, "wb")) == NULL) {
		perror(outfile);
		exit(1);
	}

	for (i = 0;i < TR0SEC;i ++) {
		for (k = 0;k < TR0BYTE;k ++) {
			fputc(track0[i][k],outfp);
		}
	}

	fclose(outfp);

	for (fileno = 0;fileno < MAXFILE;fileno ++) {
		fileptr = fileno * 0x10;

		if (diskimg[1][0][fileptr] == 0x00) {
			continue;
		}

		if (diskimg[1][0][fileptr] == 0xff) {
				diskimg[a0*2+a1][a2-1][k] = (unsigned char)c;
			continue;
		}

		for (i = 0;i < 6;i ++) {
			c = diskimg[1][0][fileptr + i];
			if (c == 0x20) {
				c = 0x00;
			}
			outfile[i] = c;
		}
		outfile[i] = 0x00;

		printf("Generate file : %s\n",outfile);

		if ((outfp = fopen(outfile, "wb")) == NULL) {
			perror(outfile);
			exit(1);
		}


		f_sttrk = diskimg[1][0][fileptr + 12];
		f_stsec = diskimg[1][0][fileptr + 13];
		f_edtrk = diskimg[1][0][fileptr + 14];
		f_edsec = diskimg[1][0][fileptr + 15];

		stflag = 1;
		for (i = f_sttrk;;i ++) {
			for (j = 1;j <= 5;j ++) {

				if (stflag == 1) {
					j = f_stsec;
					stflag = 0;
				}

				for (k = 0;k < SECBYTE;k ++) {

					fputc(diskimg[i][j-1][k],outfp);

				}

				if (i == f_edtrk && j == f_edsec) {
					break;
				}

			}

			if (i == f_edtrk && j == f_edsec) {
				break;
			}

		}

		fclose(outfp);

	}

	fclose(infp);


	return(0);
}
